/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the MessageButton type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageButton{}

// MessageButton `auto_short_link`, `expired_url` and `ttl` work for type `url` only
type MessageButton struct {
	Type MessageButtonType `json:"type"`
	Text string `json:"text"`
	Payload *string `json:"payload,omitempty"`
	AutoShortLink *bool `json:"auto_short_link,omitempty"`
	ExpiredUrl *string `json:"expired_url,omitempty"`
	Ttl *int32 `json:"ttl,omitempty"`
}

// NewMessageButton instantiates a new MessageButton object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageButton(type_ MessageButtonType, text string) *MessageButton {
	this := MessageButton{}
	this.Type = type_
	this.Text = text
	return &this
}

// NewMessageButtonWithDefaults instantiates a new MessageButton object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageButtonWithDefaults() *MessageButton {
	this := MessageButton{}
	return &this
}

// GetType returns the Type field value
func (o *MessageButton) GetType() MessageButtonType {
	if o == nil {
		var ret MessageButtonType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *MessageButton) GetTypeOk() (*MessageButtonType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *MessageButton) SetType(v MessageButtonType) {
	o.Type = v
}

// GetText returns the Text field value
func (o *MessageButton) GetText() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Text
}

// GetTextOk returns a tuple with the Text field value
// and a boolean to check if the value has been set.
func (o *MessageButton) GetTextOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Text, true
}

// SetText sets field value
func (o *MessageButton) SetText(v string) {
	o.Text = v
}

// GetPayload returns the Payload field value if set, zero value otherwise.
func (o *MessageButton) GetPayload() string {
	if o == nil || IsNil(o.Payload) {
		var ret string
		return ret
	}
	return *o.Payload
}

// GetPayloadOk returns a tuple with the Payload field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageButton) GetPayloadOk() (*string, bool) {
	if o == nil || IsNil(o.Payload) {
		return nil, false
	}
	return o.Payload, true
}

// HasPayload returns a boolean if a field has been set.
func (o *MessageButton) HasPayload() bool {
	if o != nil && !IsNil(o.Payload) {
		return true
	}

	return false
}

// SetPayload gets a reference to the given string and assigns it to the Payload field.
func (o *MessageButton) SetPayload(v string) {
	o.Payload = &v
}

// GetAutoShortLink returns the AutoShortLink field value if set, zero value otherwise.
func (o *MessageButton) GetAutoShortLink() bool {
	if o == nil || IsNil(o.AutoShortLink) {
		var ret bool
		return ret
	}
	return *o.AutoShortLink
}

// GetAutoShortLinkOk returns a tuple with the AutoShortLink field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageButton) GetAutoShortLinkOk() (*bool, bool) {
	if o == nil || IsNil(o.AutoShortLink) {
		return nil, false
	}
	return o.AutoShortLink, true
}

// HasAutoShortLink returns a boolean if a field has been set.
func (o *MessageButton) HasAutoShortLink() bool {
	if o != nil && !IsNil(o.AutoShortLink) {
		return true
	}

	return false
}

// SetAutoShortLink gets a reference to the given bool and assigns it to the AutoShortLink field.
func (o *MessageButton) SetAutoShortLink(v bool) {
	o.AutoShortLink = &v
}

// GetExpiredUrl returns the ExpiredUrl field value if set, zero value otherwise.
func (o *MessageButton) GetExpiredUrl() string {
	if o == nil || IsNil(o.ExpiredUrl) {
		var ret string
		return ret
	}
	return *o.ExpiredUrl
}

// GetExpiredUrlOk returns a tuple with the ExpiredUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageButton) GetExpiredUrlOk() (*string, bool) {
	if o == nil || IsNil(o.ExpiredUrl) {
		return nil, false
	}
	return o.ExpiredUrl, true
}

// HasExpiredUrl returns a boolean if a field has been set.
func (o *MessageButton) HasExpiredUrl() bool {
	if o != nil && !IsNil(o.ExpiredUrl) {
		return true
	}

	return false
}

// SetExpiredUrl gets a reference to the given string and assigns it to the ExpiredUrl field.
func (o *MessageButton) SetExpiredUrl(v string) {
	o.ExpiredUrl = &v
}

// GetTtl returns the Ttl field value if set, zero value otherwise.
func (o *MessageButton) GetTtl() int32 {
	if o == nil || IsNil(o.Ttl) {
		var ret int32
		return ret
	}
	return *o.Ttl
}

// GetTtlOk returns a tuple with the Ttl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageButton) GetTtlOk() (*int32, bool) {
	if o == nil || IsNil(o.Ttl) {
		return nil, false
	}
	return o.Ttl, true
}

// HasTtl returns a boolean if a field has been set.
func (o *MessageButton) HasTtl() bool {
	if o != nil && !IsNil(o.Ttl) {
		return true
	}

	return false
}

// SetTtl gets a reference to the given int32 and assigns it to the Ttl field.
func (o *MessageButton) SetTtl(v int32) {
	o.Ttl = &v
}

func (o MessageButton) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageButton) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["type"] = o.Type
	toSerialize["text"] = o.Text
	if !IsNil(o.Payload) {
		toSerialize["payload"] = o.Payload
	}
	if !IsNil(o.AutoShortLink) {
		toSerialize["auto_short_link"] = o.AutoShortLink
	}
	if !IsNil(o.ExpiredUrl) {
		toSerialize["expired_url"] = o.ExpiredUrl
	}
	if !IsNil(o.Ttl) {
		toSerialize["ttl"] = o.Ttl
	}
	return toSerialize, nil
}

type NullableMessageButton struct {
	value *MessageButton
	isSet bool
}

func (v NullableMessageButton) Get() *MessageButton {
	return v.value
}

func (v *NullableMessageButton) Set(val *MessageButton) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageButton) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageButton) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageButton(val *MessageButton) *NullableMessageButton {
	return &NullableMessageButton{value: val, isSet: true}
}

func (v NullableMessageButton) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageButton) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


